Log4j 1.2.7

## org.apache.log4j
Class WriterAppender

    java.lang.Object
      |
      +--org.apache.log4j.AppenderSkeleton
            |
            +--org.apache.log4j.WriterAppender

All Implemented Interfaces:
  Appender, OptionHandler

Direct Known Subclasses:
  ConsoleAppender, FileAppender

public class WriterAppender
extends AppenderSkeleton

WriterAppender appends log events to a `Writer` or an `OutputStream` depending on the user's choice.

Since:
  1.1
Author:
  Ceki Gülcü

Field Summary
`protected String` `encoding` The encoding to use when opening an InputStream.
`protected boolean` `immediateFlush` Immediate flush means that the underlying writer or output stream will be flushed at the end of each append operation.
`protected QuietWriter` `qw` This is the `quietWriter` where we will write to.

Fields inherited from class org.apache.log4j.AppenderSkeleton
`closed, errorHandler, headFilter, layout, name, tailFilter, threshold`

Constructor Summary
`WriterAppender()` This default constructor does nothing.
`WriterAppender(Layout layout, OutputStream os)` Instantiate a WriterAppender and set the output destination to a new `OutputStreamWriter` initialized with `os` as its `OutputStream`.
`WriterAppender(Layout layout, Writer writer)` Instantiate a WriterAppender and set the output destination to `writer`.

Method Summary
`void` `activateOptions()` Does nothing.
`void` `append(LoggingEvent event)` This method is called by the `AppenderSkeleton.doAppend(org.apache.log4j.spi.LoggingEvent)` method.
`protected boolean` `checkEntryConditions()` This method determines if there is a sense in attempting to append.
`void` `close()` Close this appender instance.
`protected void` `closeWriter()` Close the underlying `Writer`.
`protected OutputStreamWriter` `createWriter(OutputStream os)` Returns an OutputStreamWriter when passed an OutputStream.
`String` `getEncoding()`
`boolean` `getImmediateFlush()` Returns value of the ImmediateFlush option.
`boolean` `requiresLayout()` The WriterAppender requires a layout.
`protected void` `reset()` Clear internal references to the writer and other variables.
`void` `setEncoding(String value)`
`void` `setErrorHandler(ErrorHandler eh)` Set the `ErrorHandler` for this WriterAppender and also the underlying `QuietWriter` if any.
`void` `setImmediateFlush(boolean value)` If the ImmediateFlush option is set to `true`, the appender will flush at the end of each write.
`void` `setWriter(Writer writer)` Sets the Writer where the log output will go.
`protected void` `subAppend(LoggingEvent event)` Actual writing occurs here.
`protected void` `writeFooter()` Write a footer as produced by the embedded layout's `Layout.getFooter()` method.
`protected void` `writeHeader()` Write a header as produced by the embedded layout's `Layout.getHeader()` method.

Methods inherited from class org.apache.log4j.AppenderSkeleton
`addFilter, clearFilters, doAppend, finalize, getErrorHandler, getFilter, getFirstFilter, getLayout, getName, getThreshold, isAsSevereAsThreshold, setLayout, setName, setThreshold`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### immediateFlush

    protected boolean immediateFlush

  Immediate flush means that the underlying writer or output stream will be flushed at the end of each append operation. Immediate flush is slower but ensures that each append request is actually written. If `immediateFlush` is set to `false`, then there is a good chance that the last few logs events are not actually written to persistent media if and when the application crashes.

  The `immediateFlush` variable is set to `true` by default.

### encoding

    protected String encoding

  The encoding to use when opening an InputStream.

  The `encoding` variable is set to `null</null> by default which results in the utilization of the system's default encoding.`

### qw

    protected QuietWriter qw

  This is the `quietWriter` where we will write to.

Constructor Detail

### WriterAppender

    public WriterAppender()

  This default constructor does nothing.

### WriterAppender

    public WriterAppender(Layout layout,
                          OutputStream os)

  Instantiate a WriterAppender and set the output destination to a new `OutputStreamWriter` initialized with `os` as its `OutputStream`.

### WriterAppender

    public WriterAppender(Layout layout,
                          Writer writer)

  Instantiate a WriterAppender and set the output destination to `writer`.

  The `writer` must have been previously opened by the user.

Method Detail

### setImmediateFlush

    public void setImmediateFlush(boolean value)

  If the ImmediateFlush option is set to `true`, the appender will flush at the end of each write. This is the default behavior. If the option is set to `false`, then the underlying stream can defer writing to physical medium to a later time.

  Avoiding the flush operation at the end of each append results in a performance gain of 10 to 20 percent. However, there is safety tradeoff involved in skipping flushing. Indeed, when flushing is skipped, then it is likely that the last few log events will not be recorded on disk when the application exits. This is a high price to pay even for a 20% performance gain.

### getImmediateFlush

    public boolean getImmediateFlush()

  Returns value of the ImmediateFlush option.

### activateOptions

    public void activateOptions()

  Does nothing.
  Overrides:
    `activateOptions` in class `AppenderSkeleton`

### append

    public void append(LoggingEvent event)

  This method is called by the `AppenderSkeleton.doAppend(org.apache.log4j.spi.LoggingEvent)` method.

  If the output stream exists and is writable then write a log statement to the output stream. Otherwise, write a single warning message to `System.err`.

  The format of the output will depend on this appender's layout.

  Overrides:
    `append` in class `AppenderSkeleton`

### checkEntryConditions

    protected boolean checkEntryConditions()

  This method determines if there is a sense in attempting to append.

  It checks whether there is a set output target and also if there is a set layout. If these checks fail, then the boolean value `false` is returned.

### close

    public void close()

  Close this appender instance. The underlying stream or writer is also closed.

  Closed appenders cannot be reused.

  Since:
    0.8.4
  See Also:
    `setWriter(java.io.Writer)`

### closeWriter

    protected void closeWriter()

  Close the underlying `Writer`.

### createWriter

    protected OutputStreamWriter createWriter(OutputStream os)

  Returns an OutputStreamWriter when passed an OutputStream. The encoding used will depend on the value of the `encoding` property. If the encoding value is specified incorrectly the writer will be opened using the default system encoding (an error message will be printed to the loglog.

### getEncoding

    public String getEncoding()

### setEncoding

    public void setEncoding(String value)

### setErrorHandler

    public void setErrorHandler(ErrorHandler eh)

  Set the `ErrorHandler` for this WriterAppender and also the underlying `QuietWriter` if any.
  Overrides:
    `setErrorHandler` in class `AppenderSkeleton`

### setWriter

    public void setWriter(Writer writer)

  Sets the Writer where the log output will go. The specified Writer must be opened by the user and be writable.

  The `java.io.Writer` will be closed when the appender instance is closed.

  WARNING: Logging to an unopened Writer will fail.

  Parameters:
    `writer` - An already opened Writer.

### subAppend

    protected void subAppend(LoggingEvent event)

  Actual writing occurs here.

  Most subclasses of `WriterAppender` will need to override this method.

  Since:
    0.9.0

### requiresLayout

    public boolean requiresLayout()

  The WriterAppender requires a layout. Hence, this method returns `true`.

### reset

    protected void reset()

  Clear internal references to the writer and other variables. Subclasses can override this method for an alternate closing behavior.

### writeFooter

    protected void writeFooter()

  Write a footer as produced by the embedded layout's `Layout.getFooter()` method.

### writeHeader

    protected void writeHeader()

  Write a header as produced by the embedded layout's `Layout.getHeader()` method.

Log4j 1.2.7

Copyright 2000-2002 Apache Software Foundation.